<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: flair::meta::UavStateMachine Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classflair_1_1meta_1_1_uav_state_machine.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classflair_1_1meta_1_1_uav_state_machine-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">flair::meta::UavStateMachine Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>State machine for UAV The Thread is created with the FrameworkManager as parent. FrameworkManager must be created before. The Thread is synchronized with Ahrs, unless a period is set with SetPeriodUS or SetPeriodMS.  
 <a href="classflair_1_1meta_1_1_uav_state_machine.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_uav_state_machine_8h_source.html">UavStateMachine.h</a>&gt;</code></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for flair::meta::UavStateMachine:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classflair_1_1meta_1_1_uav_state_machine.png" usemap="#flair::meta::UavStateMachine_map" alt=""/>
  <map id="flair::meta::UavStateMachine_map" name="flair::meta::UavStateMachine_map">
<area href="classflair_1_1core_1_1_thread.html" title="Abstract class for a thread. " alt="flair::core::Thread" shape="rect" coords="0,56,171,80"/>
<area href="classflair_1_1core_1_1_object.html" title="Base class for all Framework&#39;s classes. " alt="flair::core::Object" shape="rect" coords="0,0,171,24"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr class="memitem:a70c5fee2723003181c3f40304ff161b9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a70c5fee2723003181c3f40304ff161b9"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><b>AltitudeMode_t</b> { <b>Manual</b>, 
<b>Custom</b>
 }</td></tr>
<tr class="separator:a70c5fee2723003181c3f40304ff161b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b7de00de9545a3f7d1019a643465612"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3b7de00de9545a3f7d1019a643465612"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><b>OrientationMode_t</b> { <b>Manual</b>, 
<b>Custom</b>
 }</td></tr>
<tr class="separator:a3b7de00de9545a3f7d1019a643465612"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae053854466a1dbd5d88fe25ec7111731"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae053854466a1dbd5d88fe25ec7111731"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><b>ThrustMode_t</b> { <b>Default</b>, 
<b>Custom</b>
 }</td></tr>
<tr class="separator:ae053854466a1dbd5d88fe25ec7111731"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a753e0ed184288600a6c404a1007d2578"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a753e0ed184288600a6c404a1007d2578"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><b>TorqueMode_t</b> { <b>Default</b>, 
<b>Custom</b>
 }</td></tr>
<tr class="separator:a753e0ed184288600a6c404a1007d2578"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8c303819c3981685f734cb40a3e1e1fa"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8c303819c3981685f734cb40a3e1e1fa"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><b>Event_t</b> { <br />
&#160;&#160;<b>EnteringFailSafeMode</b>, 
<b>EnteringControlLoop</b>, 
<b>StartLanding</b>, 
<b>FinishLanding</b>, 
<br />
&#160;&#160;<b>Stopped</b>, 
<b>TakingOff</b>, 
<b>EmergencyStop</b>, 
<b>Stabilized</b>, 
<br />
&#160;&#160;<b>ZTrajectoryFinished</b>
<br />
 }</td></tr>
<tr class="separator:a8c303819c3981685f734cb40a3e1e1fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a95ee0204cc898cb8e5179ccc5d1dc1f5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a95ee0204cc898cb8e5179ccc5d1dc1f5"></a>
const AltitudeMode_t &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>GetAltitudeMode</b> (void) const </td></tr>
<tr class="separator:a95ee0204cc898cb8e5179ccc5d1dc1f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1117a954c13aa97aa5d688e4486e29fa"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1117a954c13aa97aa5d688e4486e29fa"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>SetAltitudeMode</b> (const AltitudeMode_t &amp;altitudeMode)</td></tr>
<tr class="separator:a1117a954c13aa97aa5d688e4486e29fa"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a91c1396bbf486ddd5cde6072b222543d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a91c1396bbf486ddd5cde6072b222543d"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>GotoAltitude</b> (float desiredAltitude)</td></tr>
<tr class="separator:a91c1396bbf486ddd5cde6072b222543d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5d199a6fe92006ab0a76eda9b723a256"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5d199a6fe92006ab0a76eda9b723a256"></a>
const OrientationMode_t &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>GetOrientationMode</b> (void) const </td></tr>
<tr class="separator:a5d199a6fe92006ab0a76eda9b723a256"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0f23419faaab13495889b5769e94c085"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0f23419faaab13495889b5769e94c085"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>SetOrientationMode</b> (const OrientationMode_t &amp;orientationMode)</td></tr>
<tr class="separator:a0f23419faaab13495889b5769e94c085"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a45b552098e86c12fb4024785c1d95516"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a45b552098e86c12fb4024785c1d95516"></a>
const ThrustMode_t &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>GetThrustMode</b> () const </td></tr>
<tr class="separator:a45b552098e86c12fb4024785c1d95516"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a865806d5064cb8f8995ce5e9f1222ba4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a865806d5064cb8f8995ce5e9f1222ba4"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>SetThrustMode</b> (const ThrustMode_t &amp;thrustMode)</td></tr>
<tr class="separator:a865806d5064cb8f8995ce5e9f1222ba4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a781f9c95e92023074c0a1587cfefe798"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a781f9c95e92023074c0a1587cfefe798"></a>
const TorqueMode_t &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>GetTorqueMode</b> (void) const </td></tr>
<tr class="separator:a781f9c95e92023074c0a1587cfefe798"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70002c653806c3e18f3f04ae46b4e24b"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a70002c653806c3e18f3f04ae46b4e24b"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>SetTorqueMode</b> (const TorqueMode_t &amp;torqueMode)</td></tr>
<tr class="separator:a70002c653806c3e18f3f04ae46b4e24b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada2a19a4fdf6a861d81078347d721d40"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ada2a19a4fdf6a861d81078347d721d40"></a>
&#160;</td><td class="memItemRight" valign="bottom"><b>UavStateMachine</b> (<a class="el" href="classflair_1_1sensor_1_1_target_controller.html">sensor::TargetController</a> *controller)</td></tr>
<tr class="separator:ada2a19a4fdf6a861d81078347d721d40"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae632fa95dfbd03b2459390c0aa97b7c4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ae632fa95dfbd03b2459390c0aa97b7c4"></a>
const <a class="el" href="classflair_1_1core_1_1_quaternion.html">core::Quaternion</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>GetCurrentQuaternion</b> (void) const </td></tr>
<tr class="separator:ae632fa95dfbd03b2459390c0aa97b7c4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abeb4955dc8ace81d74fe6e7eb5c952e4"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="abeb4955dc8ace81d74fe6e7eb5c952e4"></a>
const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">core::Vector3Df</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>GetCurrentAngularSpeed</b> (void) const </td></tr>
<tr class="separator:abeb4955dc8ace81d74fe6e7eb5c952e4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a08afc337453ad8587ff07c0c07c1d42f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a08afc337453ad8587ff07c0c07c1d42f"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>Land</b> (void)</td></tr>
<tr class="separator:a08afc337453ad8587ff07c0c07c1d42f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0e53dbcb461575eed6f2cfefe7aa9437"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a0e53dbcb461575eed6f2cfefe7aa9437"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>EmergencyLand</b> (void)</td></tr>
<tr class="separator:a0e53dbcb461575eed6f2cfefe7aa9437"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a479a742afa89d898c03aeb0a06d8f290"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a479a742afa89d898c03aeb0a06d8f290"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>TakeOff</b> (void)</td></tr>
<tr class="separator:a479a742afa89d898c03aeb0a06d8f290"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a47ae3142c18f797bfba0b209e8518650"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a47ae3142c18f797bfba0b209e8518650"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>EmergencyStop</b> (void)</td></tr>
<tr class="separator:a47ae3142c18f797bfba0b209e8518650"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a734a11e3bbedd8dd1726b2c450353da5"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html#a734a11e3bbedd8dd1726b2c450353da5">SignalEvent</a> (Event_t event)</td></tr>
<tr class="memdesc:a734a11e3bbedd8dd1726b2c450353da5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Used to signal an event.  <a href="#a734a11e3bbedd8dd1726b2c450353da5">More...</a><br /></td></tr>
<tr class="separator:a734a11e3bbedd8dd1726b2c450353da5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af61a3a807c656973d67f51630019310e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af61a3a807c656973d67f51630019310e"></a>
virtual const <a class="el" href="classflair_1_1core_1_1_ahrs_data.html">core::AhrsData</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>GetOrientation</b> (void) const </td></tr>
<tr class="separator:af61a3a807c656973d67f51630019310e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6b98450ff11f0d3bb4e72c03f654f293"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6b98450ff11f0d3bb4e72c03f654f293"></a>
const <a class="el" href="classflair_1_1core_1_1_ahrs_data.html">core::AhrsData</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>GetDefaultOrientation</b> (void) const </td></tr>
<tr class="separator:a6b98450ff11f0d3bb4e72c03f654f293"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac335dfcc3c91af9e59dc10d88c1da04f"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ac335dfcc3c91af9e59dc10d88c1da04f"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><b>AltitudeValues</b> (float &amp;z, float &amp;dz) const </td></tr>
<tr class="separator:ac335dfcc3c91af9e59dc10d88c1da04f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f2db381f71bae4f92395df4400d6e0c"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2f2db381f71bae4f92395df4400d6e0c"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>EnterFailSafeMode</b> (void)</td></tr>
<tr class="separator:a2f2db381f71bae4f92395df4400d6e0c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab2ed3ee4d9ccdbc2bb813a9b55a0d544"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab2ed3ee4d9ccdbc2bb813a9b55a0d544"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><b>ExitFailSafeMode</b> (void)</td></tr>
<tr class="separator:ab2ed3ee4d9ccdbc2bb813a9b55a0d544"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd12763a492e5d257da5ce1370a6d560"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acd12763a492e5d257da5ce1370a6d560"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>FailSafeAltitudeValues</b> (float &amp;z, float &amp;dz) const </td></tr>
<tr class="separator:acd12763a492e5d257da5ce1370a6d560"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7fe403c4baa571230206581bfb423434"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a7fe403c4baa571230206581bfb423434"></a>
<a class="el" href="classflair_1_1gui_1_1_grid_layout.html">gui::GridLayout</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>GetButtonsLayout</b> (void) const </td></tr>
<tr class="separator:a7fe403c4baa571230206581bfb423434"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4d6998ef27892a685ff1f0d1be600f72"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4d6998ef27892a685ff1f0d1be600f72"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><b>ExtraSecurityCheck</b> (void)</td></tr>
<tr class="separator:a4d6998ef27892a685ff1f0d1be600f72"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a391e18a04f86f1660f9cb995e052cfac"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a391e18a04f86f1660f9cb995e052cfac"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><b>ExtraCheckJoystick</b> (void)</td></tr>
<tr class="separator:a391e18a04f86f1660f9cb995e052cfac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab00c67c969f749b25c9c442debfbbdd2"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab00c67c969f749b25c9c442debfbbdd2"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><b>ExtraCheckPushButton</b> (void)</td></tr>
<tr class="separator:ab00c67c969f749b25c9c442debfbbdd2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a24c592e8b5013dfe9f494831d7edfacb"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a24c592e8b5013dfe9f494831d7edfacb"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><b>GetDefaultReferenceAltitude</b> (float &amp;refAltitude, float &amp;refVerticalVelocity)</td></tr>
<tr class="separator:a24c592e8b5013dfe9f494831d7edfacb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9f97b96be1eaaab9dcb9e1a245b614f2"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9f97b96be1eaaab9dcb9e1a245b614f2"></a>
virtual void&#160;</td><td class="memItemRight" valign="bottom"><b>GetReferenceAltitude</b> (float &amp;refAltitude, float &amp;refVerticalVelocity)</td></tr>
<tr class="separator:a9f97b96be1eaaab9dcb9e1a245b614f2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acb613e16c489a521c664817ef74f00d9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="acb613e16c489a521c664817ef74f00d9"></a>
const <a class="el" href="classflair_1_1core_1_1_ahrs_data.html">core::AhrsData</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>GetDefaultReferenceOrientation</b> (void) const </td></tr>
<tr class="separator:acb613e16c489a521c664817ef74f00d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9340da0cfbec2e72f323e51a43ae0b19"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9340da0cfbec2e72f323e51a43ae0b19"></a>
virtual const <a class="el" href="classflair_1_1core_1_1_ahrs_data.html">core::AhrsData</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>GetReferenceOrientation</b> (void)</td></tr>
<tr class="separator:a9340da0cfbec2e72f323e51a43ae0b19"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a239d9f75ff1a46752c2b06c37726336a"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html#a239d9f75ff1a46752c2b06c37726336a">ComputeCustomTorques</a> (<a class="el" href="classflair_1_1core_1_1_euler.html">core::Euler</a> &amp;torques)</td></tr>
<tr class="memdesc:a239d9f75ff1a46752c2b06c37726336a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute Custom Torques.  <a href="#a239d9f75ff1a46752c2b06c37726336a">More...</a><br /></td></tr>
<tr class="separator:a239d9f75ff1a46752c2b06c37726336a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac93d0d595a86a014c27375c973f693a8"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html#ac93d0d595a86a014c27375c973f693a8">ComputeDefaultTorques</a> (<a class="el" href="classflair_1_1core_1_1_euler.html">core::Euler</a> &amp;torques)</td></tr>
<tr class="memdesc:ac93d0d595a86a014c27375c973f693a8"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute Default Torques.  <a href="#ac93d0d595a86a014c27375c973f693a8">More...</a><br /></td></tr>
<tr class="separator:ac93d0d595a86a014c27375c973f693a8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6af7f575d90ef500717a999ea4c4afef"><td class="memItemLeft" align="right" valign="top">virtual float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html#a6af7f575d90ef500717a999ea4c4afef">ComputeCustomThrust</a> (void)</td></tr>
<tr class="memdesc:a6af7f575d90ef500717a999ea4c4afef"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get Torques.  <a href="#a6af7f575d90ef500717a999ea4c4afef">More...</a><br /></td></tr>
<tr class="separator:a6af7f575d90ef500717a999ea4c4afef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab25472bbf51a7baf97ec5e9cfc148f8b"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html#ab25472bbf51a7baf97ec5e9cfc148f8b">ComputeDefaultThrust</a> (void)</td></tr>
<tr class="memdesc:ab25472bbf51a7baf97ec5e9cfc148f8b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Compute Default Thrust.  <a href="#ab25472bbf51a7baf97ec5e9cfc148f8b">More...</a><br /></td></tr>
<tr class="separator:ab25472bbf51a7baf97ec5e9cfc148f8b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab737f2861d5c1901a0f62f54fe2c0855"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html#ab737f2861d5c1901a0f62f54fe2c0855">AddDeviceToControlLawLog</a> (const <a class="el" href="classflair_1_1core_1_1_i_o_device.html">core::IODevice</a> *device)</td></tr>
<tr class="memdesc:ab737f2861d5c1901a0f62f54fe2c0855"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get Thrust.  <a href="#ab737f2861d5c1901a0f62f54fe2c0855">More...</a><br /></td></tr>
<tr class="separator:ab737f2861d5c1901a0f62f54fe2c0855"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa642bfeb1d97dec839088e2256a3699b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html#aa642bfeb1d97dec839088e2256a3699b">AddDataToControlLawLog</a> (const <a class="el" href="classflair_1_1core_1_1io__data.html">core::io_data</a> *data)</td></tr>
<tr class="memdesc:aa642bfeb1d97dec839088e2256a3699b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Add an io_data to the control law logs.  <a href="#aa642bfeb1d97dec839088e2256a3699b">More...</a><br /></td></tr>
<tr class="separator:aa642bfeb1d97dec839088e2256a3699b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8e60c6966eb00cf63c0278d575b8e394"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a8e60c6966eb00cf63c0278d575b8e394"></a>
const <a class="el" href="classflair_1_1sensor_1_1_target_controller.html">sensor::TargetController</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>GetJoystick</b> (void) const </td></tr>
<tr class="separator:a8e60c6966eb00cf63c0278d575b8e394"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56a4bd1ccd2bd35d3f112357ce7d7354"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a56a4bd1ccd2bd35d3f112357ce7d7354"></a>
<a class="el" href="classflair_1_1filter_1_1_nested_sat.html">filter::NestedSat</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>GetURoll</b> (void)</td></tr>
<tr class="separator:a56a4bd1ccd2bd35d3f112357ce7d7354"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5206c6547f6c5ee803f61c2b651b6a46"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a5206c6547f6c5ee803f61c2b651b6a46"></a>
<a class="el" href="classflair_1_1filter_1_1_nested_sat.html">filter::NestedSat</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>GetUPitch</b> (void)</td></tr>
<tr class="separator:a5206c6547f6c5ee803f61c2b651b6a46"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9711cbe4ded896b21745d29c9ed27531"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9711cbe4ded896b21745d29c9ed27531"></a>
<a class="el" href="classflair_1_1filter_1_1_pid.html">filter::Pid</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>GetUYaw</b> (void)</td></tr>
<tr class="separator:a9711cbe4ded896b21745d29c9ed27531"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab86952dbc6e7f4c8518020f0b67b68e5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab86952dbc6e7f4c8518020f0b67b68e5"></a>
<a class="el" href="classflair_1_1filter_1_1_pid_thrust.html">filter::PidThrust</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>GetUZ</b> (void)</td></tr>
<tr class="separator:ab86952dbc6e7f4c8518020f0b67b68e5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab8b3d2da5d89e9a7faa17de65a7cf0eb"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab8b3d2da5d89e9a7faa17de65a7cf0eb"></a>
<a class="el" href="classflair_1_1filter_1_1_trajectory_generator1_d.html">filter::TrajectoryGenerator1D</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>GetAltitudeTrajectory</b> (void)</td></tr>
<tr class="separator:ab8b3d2da5d89e9a7faa17de65a7cf0eb"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a3929dfba87003f40ce398a123616dd48"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3929dfba87003f40ce398a123616dd48"></a>
<a class="el" href="classflair_1_1meta_1_1_meta_dual_shock3.html">MetaDualShock3</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>joy</b></td></tr>
<tr class="separator:a3929dfba87003f40ce398a123616dd48"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9e5c71804025830b11104cdbe2d0f7dc"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9e5c71804025830b11104cdbe2d0f7dc"></a>
<a class="el" href="classflair_1_1gui_1_1_tab.html">gui::Tab</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>setupLawTab</b></td></tr>
<tr class="separator:a9e5c71804025830b11104cdbe2d0f7dc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a317042b2fcf037957ffc5539b8b2342e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a317042b2fcf037957ffc5539b8b2342e"></a>
<a class="el" href="classflair_1_1gui_1_1_tab.html">gui::Tab</a> *&#160;</td><td class="memItemRight" valign="bottom"><b>graphLawTab</b></td></tr>
<tr class="separator:a317042b2fcf037957ffc5539b8b2342e"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="inherited"></a>
Additional Inherited Members</h2></td></tr>
<tr class="inherit_header pub_types_classflair_1_1core_1_1_object"><td colspan="2" onclick="javascript:toggleInherit('pub_types_classflair_1_1core_1_1_object')"><img src="closed.png" alt="-"/>&#160;Public Types inherited from <a class="el" href="classflair_1_1core_1_1_object.html">flair::core::Object</a></td></tr>
<tr class="memitem:aed5fccda511f97487040fed29f4efc97 inherit pub_types_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aed5fccda511f97487040fed29f4efc97"></a>enum &#160;</td><td class="memItemRight" valign="bottom"><b>color_t</b> { <b>Auto</b> = 0, 
<b>Red</b> = 31, 
<b>Green</b> = 32, 
<b>Orange</b> = 33
 }</td></tr>
<tr class="separator:aed5fccda511f97487040fed29f4efc97 inherit pub_types_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classflair_1_1core_1_1_thread"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classflair_1_1core_1_1_thread')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classflair_1_1core_1_1_thread.html">flair::core::Thread</a></td></tr>
<tr class="memitem:adecd2fabe36298c43267557e7f016deb inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#adecd2fabe36298c43267557e7f016deb">Thread</a> (const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> *parent, std::string name, uint8_t priority, uint32_t stackSize=1024 *128)</td></tr>
<tr class="memdesc:adecd2fabe36298c43267557e7f016deb inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#adecd2fabe36298c43267557e7f016deb">More...</a><br /></td></tr>
<tr class="separator:adecd2fabe36298c43267557e7f016deb inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a39ede97ff3addeaf48ecec09c6625655 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#a39ede97ff3addeaf48ecec09c6625655">~Thread</a> ()</td></tr>
<tr class="memdesc:a39ede97ff3addeaf48ecec09c6625655 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#a39ede97ff3addeaf48ecec09c6625655">More...</a><br /></td></tr>
<tr class="separator:a39ede97ff3addeaf48ecec09c6625655 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5a4f0f27689ae4292f81bf45e22998a5 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#a5a4f0f27689ae4292f81bf45e22998a5">Start</a> (void)</td></tr>
<tr class="memdesc:a5a4f0f27689ae4292f81bf45e22998a5 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Start the thread.  <a href="#a5a4f0f27689ae4292f81bf45e22998a5">More...</a><br /></td></tr>
<tr class="separator:a5a4f0f27689ae4292f81bf45e22998a5 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa1fb0f8d5b18273394502159dd5dcef inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#afa1fb0f8d5b18273394502159dd5dcef">SafeStop</a> (void)</td></tr>
<tr class="memdesc:afa1fb0f8d5b18273394502159dd5dcef inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a stop flag.  <a href="#afa1fb0f8d5b18273394502159dd5dcef">More...</a><br /></td></tr>
<tr class="separator:afa1fb0f8d5b18273394502159dd5dcef inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afcbb4a445fe287b8608b173bdc10f056 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#afcbb4a445fe287b8608b173bdc10f056">ToBeStopped</a> (void) const </td></tr>
<tr class="memdesc:afcbb4a445fe287b8608b173bdc10f056 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a stop flag.  <a href="#afcbb4a445fe287b8608b173bdc10f056">More...</a><br /></td></tr>
<tr class="separator:afcbb4a445fe287b8608b173bdc10f056 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba8b31e2e4c1beccb31333beb8bd41a4 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#aba8b31e2e4c1beccb31333beb8bd41a4">Join</a> (void)</td></tr>
<tr class="memdesc:aba8b31e2e4c1beccb31333beb8bd41a4 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Join the thread.  <a href="#aba8b31e2e4c1beccb31333beb8bd41a4">More...</a><br /></td></tr>
<tr class="separator:aba8b31e2e4c1beccb31333beb8bd41a4 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a581ae3bdecef47c916671a6aafec9509 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#a581ae3bdecef47c916671a6aafec9509">SetPeriodUS</a> (uint32_t period_us)</td></tr>
<tr class="memdesc:a581ae3bdecef47c916671a6aafec9509 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the period in micro second.  <a href="#a581ae3bdecef47c916671a6aafec9509">More...</a><br /></td></tr>
<tr class="separator:a581ae3bdecef47c916671a6aafec9509 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab58a00466581b6cf88ba28b8e2118c65 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab58a00466581b6cf88ba28b8e2118c65"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><b>GetPeriodUS</b> () const </td></tr>
<tr class="separator:ab58a00466581b6cf88ba28b8e2118c65 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a37d13f12283d69ebd092a7cc01a7d742 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#a37d13f12283d69ebd092a7cc01a7d742">SetPeriodMS</a> (uint32_t period_ms)</td></tr>
<tr class="memdesc:a37d13f12283d69ebd092a7cc01a7d742 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Set the period in milli second.  <a href="#a37d13f12283d69ebd092a7cc01a7d742">More...</a><br /></td></tr>
<tr class="separator:a37d13f12283d69ebd092a7cc01a7d742 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afaa77472d57848bed10204ee5ec1d75a inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afaa77472d57848bed10204ee5ec1d75a"></a>
uint32_t&#160;</td><td class="memItemRight" valign="bottom"><b>GetPeriodMS</b> () const </td></tr>
<tr class="separator:afaa77472d57848bed10204ee5ec1d75a inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af892a1b3025cb842cad8e7f2a11a9526 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#af892a1b3025cb842cad8e7f2a11a9526">IsPeriodSet</a> (void)</td></tr>
<tr class="memdesc:af892a1b3025cb842cad8e7f2a11a9526 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns if period was set.  <a href="#af892a1b3025cb842cad8e7f2a11a9526">More...</a><br /></td></tr>
<tr class="separator:af892a1b3025cb842cad8e7f2a11a9526 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a50cd2ea88d538e10a30c3e6a5286a944 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#a50cd2ea88d538e10a30c3e6a5286a944">WaitPeriod</a> (void) const </td></tr>
<tr class="memdesc:a50cd2ea88d538e10a30c3e6a5286a944 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait the period.  <a href="#a50cd2ea88d538e10a30c3e6a5286a944">More...</a><br /></td></tr>
<tr class="separator:a50cd2ea88d538e10a30c3e6a5286a944 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2b5b5f3cf400729419bd864b654af252 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#a2b5b5f3cf400729419bd864b654af252">WaitUpdate</a> (const <a class="el" href="classflair_1_1core_1_1_i_o_device.html">IODevice</a> *device)</td></tr>
<tr class="memdesc:a2b5b5f3cf400729419bd864b654af252 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Wait update of an <a class="el" href="classflair_1_1core_1_1_i_o_device.html" title="Abstract class for input/ouput system. ">IODevice</a>.  <a href="#a2b5b5f3cf400729419bd864b654af252">More...</a><br /></td></tr>
<tr class="separator:a2b5b5f3cf400729419bd864b654af252 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0e5fc8919ed6042e5736a5dca5ba546b inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#a0e5fc8919ed6042e5736a5dca5ba546b">Suspend</a> (void)</td></tr>
<tr class="memdesc:a0e5fc8919ed6042e5736a5dca5ba546b inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Suspend the thread.  <a href="#a0e5fc8919ed6042e5736a5dca5ba546b">More...</a><br /></td></tr>
<tr class="separator:a0e5fc8919ed6042e5736a5dca5ba546b inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af93c2461c31a6c16958bc44189ab4253 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#af93c2461c31a6c16958bc44189ab4253">SuspendUntil</a> (<a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> date)</td></tr>
<tr class="memdesc:af93c2461c31a6c16958bc44189ab4253 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Suspend the thread with timeout.  <a href="#af93c2461c31a6c16958bc44189ab4253">More...</a><br /></td></tr>
<tr class="separator:af93c2461c31a6c16958bc44189ab4253 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae7c46910a801f1b16302570ad8ae9580 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#ae7c46910a801f1b16302570ad8ae9580">Resume</a> (void)</td></tr>
<tr class="memdesc:ae7c46910a801f1b16302570ad8ae9580 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Resume the thread.  <a href="#ae7c46910a801f1b16302570ad8ae9580">More...</a><br /></td></tr>
<tr class="separator:ae7c46910a801f1b16302570ad8ae9580 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adac9a6d336bdb50bcfa24c66943a355a inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#adac9a6d336bdb50bcfa24c66943a355a">IsSuspended</a> (void) const </td></tr>
<tr class="memdesc:adac9a6d336bdb50bcfa24c66943a355a inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Is the thread suspended?  <a href="#adac9a6d336bdb50bcfa24c66943a355a">More...</a><br /></td></tr>
<tr class="separator:adac9a6d336bdb50bcfa24c66943a355a inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2a82d0ade1418111c2a4e7d0e133696c inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#a2a82d0ade1418111c2a4e7d0e133696c">IsRunning</a> (void) const </td></tr>
<tr class="memdesc:a2a82d0ade1418111c2a4e7d0e133696c inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Is the thread running?  <a href="#a2a82d0ade1418111c2a4e7d0e133696c">More...</a><br /></td></tr>
<tr class="separator:a2a82d0ade1418111c2a4e7d0e133696c inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac09a2d745af3dbb42371949d4c622011 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#ac09a2d745af3dbb42371949d4c622011">SleepUntil</a> (<a class="el" href="namespaceflair_1_1core.html#acc0fa041e08ecf73b2d1d723c339a736">Time</a> time) const </td></tr>
<tr class="memdesc:ac09a2d745af3dbb42371949d4c622011 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sleep until absolute time.  <a href="#ac09a2d745af3dbb42371949d4c622011">More...</a><br /></td></tr>
<tr class="separator:ac09a2d745af3dbb42371949d4c622011 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3479727dfaf2213f7866fccadb43eeb6 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#a3479727dfaf2213f7866fccadb43eeb6">SleepUS</a> (uint32_t time_us) const </td></tr>
<tr class="memdesc:a3479727dfaf2213f7866fccadb43eeb6 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sleep for a certain time in micro second.  <a href="#a3479727dfaf2213f7866fccadb43eeb6">More...</a><br /></td></tr>
<tr class="separator:a3479727dfaf2213f7866fccadb43eeb6 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a501e7802d7edd7e6167d111c803b8349 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#a501e7802d7edd7e6167d111c803b8349">SleepMS</a> (uint32_t time_ms) const </td></tr>
<tr class="memdesc:a501e7802d7edd7e6167d111c803b8349 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sleep for a cartain time in milli second.  <a href="#a501e7802d7edd7e6167d111c803b8349">More...</a><br /></td></tr>
<tr class="separator:a501e7802d7edd7e6167d111c803b8349 inherit pub_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_methods_classflair_1_1core_1_1_object"><td colspan="2" onclick="javascript:toggleInherit('pub_methods_classflair_1_1core_1_1_object')"><img src="closed.png" alt="-"/>&#160;Public Member Functions inherited from <a class="el" href="classflair_1_1core_1_1_object.html">flair::core::Object</a></td></tr>
<tr class="memitem:aec92383fd5bf68d9df10414862b7e95c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#aec92383fd5bf68d9df10414862b7e95c">Object</a> (const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> *parent=NULL, std::string name=&quot;&quot;, std::string type=&quot;&quot;)</td></tr>
<tr class="memdesc:aec92383fd5bf68d9df10414862b7e95c inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#aec92383fd5bf68d9df10414862b7e95c">More...</a><br /></td></tr>
<tr class="separator:aec92383fd5bf68d9df10414862b7e95c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa2bde0e6677bbef705c96c93cb06ad09 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#aa2bde0e6677bbef705c96c93cb06ad09">~Object</a> ()</td></tr>
<tr class="memdesc:aa2bde0e6677bbef705c96c93cb06ad09 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#aa2bde0e6677bbef705c96c93cb06ad09">More...</a><br /></td></tr>
<tr class="separator:aa2bde0e6677bbef705c96c93cb06ad09 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b0344dff7e1c05424d9152c8274523a inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a9b0344dff7e1c05424d9152c8274523a">ObjectName</a> (void) const </td></tr>
<tr class="memdesc:a9b0344dff7e1c05424d9152c8274523a inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Name.  <a href="#a9b0344dff7e1c05424d9152c8274523a">More...</a><br /></td></tr>
<tr class="separator:a9b0344dff7e1c05424d9152c8274523a inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a609a250ec037fbcaf8957c8f1dcbfc53 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a609a250ec037fbcaf8957c8f1dcbfc53">ObjectType</a> (void) const </td></tr>
<tr class="memdesc:a609a250ec037fbcaf8957c8f1dcbfc53 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Type.  <a href="#a609a250ec037fbcaf8957c8f1dcbfc53">More...</a><br /></td></tr>
<tr class="separator:a609a250ec037fbcaf8957c8f1dcbfc53 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a360c112cc3017a5152ebf6e84d2efa70 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a360c112cc3017a5152ebf6e84d2efa70">Parent</a> (void) const </td></tr>
<tr class="memdesc:a360c112cc3017a5152ebf6e84d2efa70 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Parent.  <a href="#a360c112cc3017a5152ebf6e84d2efa70">More...</a><br /></td></tr>
<tr class="separator:a360c112cc3017a5152ebf6e84d2efa70 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae22db4d723ec2d50b3ba48f26a6a770c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::vector&lt; const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#ae22db4d723ec2d50b3ba48f26a6a770c">TypeChilds</a> (void) const </td></tr>
<tr class="memdesc:ae22db4d723ec2d50b3ba48f26a6a770c inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Childs of the same type.  <a href="#ae22db4d723ec2d50b3ba48f26a6a770c">More...</a><br /></td></tr>
<tr class="separator:ae22db4d723ec2d50b3ba48f26a6a770c inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a344f81cd35805a9501098bf727ac1a10 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">std::vector&lt; const <a class="el" href="classflair_1_1core_1_1_object.html">Object</a> * &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a344f81cd35805a9501098bf727ac1a10">Childs</a> (void) const </td></tr>
<tr class="memdesc:a344f81cd35805a9501098bf727ac1a10 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Childs.  <a href="#a344f81cd35805a9501098bf727ac1a10">More...</a><br /></td></tr>
<tr class="separator:a344f81cd35805a9501098bf727ac1a10 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af001feba14fc053aa778e61080a0b4cf inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#af001feba14fc053aa778e61080a0b4cf">Information</a> (const char *function, int line, const char *format,...) const </td></tr>
<tr class="memdesc:af001feba14fc053aa778e61080a0b4cf inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted information.  <a href="#af001feba14fc053aa778e61080a0b4cf">More...</a><br /></td></tr>
<tr class="separator:af001feba14fc053aa778e61080a0b4cf inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a168b18451b2ee6126e1e81d452005ff6 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a168b18451b2ee6126e1e81d452005ff6">Warning</a> (const char *function, const char *format,...) const </td></tr>
<tr class="memdesc:a168b18451b2ee6126e1e81d452005ff6 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted warning.  <a href="#a168b18451b2ee6126e1e81d452005ff6">More...</a><br /></td></tr>
<tr class="separator:a168b18451b2ee6126e1e81d452005ff6 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3ca9694d29ec2b0491739879685df5ca inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a3ca9694d29ec2b0491739879685df5ca">Error</a> (const char *function, const char *format,...) const </td></tr>
<tr class="memdesc:a3ca9694d29ec2b0491739879685df5ca inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Formatted error.  <a href="#a3ca9694d29ec2b0491739879685df5ca">More...</a><br /></td></tr>
<tr class="separator:a3ca9694d29ec2b0491739879685df5ca inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a36cdd7f556e78b1bddd1d1fe4264bb85 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_object.html#a36cdd7f556e78b1bddd1d1fe4264bb85">ErrorOccured</a> (bool recursive=true) const </td></tr>
<tr class="memdesc:a36cdd7f556e78b1bddd1d1fe4264bb85 inherit pub_methods_classflair_1_1core_1_1_object"><td class="mdescLeft">&#160;</td><td class="mdescRight">Has an errror occured?  <a href="#a36cdd7f556e78b1bddd1d1fe4264bb85">More...</a><br /></td></tr>
<tr class="separator:a36cdd7f556e78b1bddd1d1fe4264bb85 inherit pub_methods_classflair_1_1core_1_1_object"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="inherit_header pub_static_methods_classflair_1_1core_1_1_thread"><td colspan="2" onclick="javascript:toggleInherit('pub_static_methods_classflair_1_1core_1_1_thread')"><img src="closed.png" alt="-"/>&#160;Static Public Member Functions inherited from <a class="el" href="classflair_1_1core_1_1_thread.html">flair::core::Thread</a></td></tr>
<tr class="memitem:a7fbf5ad201e7e802f0fa127891849dc9 inherit pub_static_methods_classflair_1_1core_1_1_thread"><td class="memItemLeft" align="right" valign="top">static void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_thread.html#a7fbf5ad201e7e802f0fa127891849dc9">WarnUponSwitches</a> (bool enable)</td></tr>
<tr class="memdesc:a7fbf5ad201e7e802f0fa127891849dc9 inherit pub_static_methods_classflair_1_1core_1_1_thread"><td class="mdescLeft">&#160;</td><td class="mdescRight">Warn if real time / non real time switches occur.  <a href="#a7fbf5ad201e7e802f0fa127891849dc9">More...</a><br /></td></tr>
<tr class="separator:a7fbf5ad201e7e802f0fa127891849dc9 inherit pub_static_methods_classflair_1_1core_1_1_thread"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>State machine for UAV The Thread is created with the FrameworkManager as parent. FrameworkManager must be created before. The Thread is synchronized with Ahrs, unless a period is set with SetPeriodUS or SetPeriodMS. </p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a734a11e3bbedd8dd1726b2c450353da5"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void flair::meta::UavStateMachine::SignalEvent </td>
          <td>(</td>
          <td class="paramtype">Event_t&#160;</td>
          <td class="paramname"><em>event</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Used to signal an event. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">event</td><td>the event which occured </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a239d9f75ff1a46752c2b06c37726336a"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void flair::meta::UavStateMachine::ComputeCustomTorques </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classflair_1_1core_1_1_euler.html">core::Euler</a> &amp;&#160;</td>
          <td class="paramname"><em>torques</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Compute Custom Torques. </p>
<p>Reimplement this method to use TorqueMode_t::Custom. <br />
 This method is called internally by <a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html" title="State machine for UAV The Thread is created with the FrameworkManager as parent. FrameworkManager mus...">UavStateMachine</a>, do not call it by yourself. <br />
 See GetTorques if you need torques values.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">torques</td><td>custom torques </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ac93d0d595a86a014c27375c973f693a8"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void flair::meta::UavStateMachine::ComputeDefaultTorques </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classflair_1_1core_1_1_euler.html">core::Euler</a> &amp;&#160;</td>
          <td class="paramname"><em>torques</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Compute Default Torques. </p>
<p>This method is called internally by <a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html" title="State machine for UAV The Thread is created with the FrameworkManager as parent. FrameworkManager mus...">UavStateMachine</a> when using TorqueMode_t::Default. <br />
 Torques are only computed once by loop, other calls to this method will use previously computed torques.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">torques</td><td>default torques </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a6af7f575d90ef500717a999ea4c4afef"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual float flair::meta::UavStateMachine::ComputeCustomThrust </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get Torques. </p>
<dl class="section return"><dt>Returns</dt><dd>torques current torques</dd></dl>
<p>Compute Custom Thrust</p>
<p>Reimplement this method to use ThrustMode_t::Custom. <br />
 This method is called internally by <a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html" title="State machine for UAV The Thread is created with the FrameworkManager as parent. FrameworkManager mus...">UavStateMachine</a>, do not call it by yourself. <br />
 See GetThrust if you need thrust value.</p>
<dl class="section return"><dt>Returns</dt><dd>custom Thrust </dd></dl>

</div>
</div>
<a class="anchor" id="ab25472bbf51a7baf97ec5e9cfc148f8b"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">float flair::meta::UavStateMachine::ComputeDefaultThrust </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Compute Default Thrust. </p>
<p>This method is called internally by <a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html" title="State machine for UAV The Thread is created with the FrameworkManager as parent. FrameworkManager mus...">UavStateMachine</a> when using ThrustMode_t::Default. <br />
 Thrust is only computed once by loop, other calls to this method will use previously computed thrust.</p>
<dl class="section return"><dt>Returns</dt><dd>default thrust </dd></dl>

</div>
</div>
<a class="anchor" id="ab737f2861d5c1901a0f62f54fe2c0855"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void flair::meta::UavStateMachine::AddDeviceToControlLawLog </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1_i_o_device.html">core::IODevice</a> *&#160;</td>
          <td class="paramname"><em>device</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get Thrust. </p>
<dl class="section return"><dt>Returns</dt><dd>current thrust</dd></dl>
<p>Add an IODevice to the control law logs</p>
<p>The IODevice will be automatically logged among the Uz logs, if logging is enabled (see IODevice::SetDataToLog, FrameworkManager::StartLog and FrameworkManager::AddDeviceToLog). <br />
 </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">device</td><td>IODevice to log </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aa642bfeb1d97dec839088e2256a3699b"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void flair::meta::UavStateMachine::AddDataToControlLawLog </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1io__data.html">core::io_data</a> *&#160;</td>
          <td class="paramname"><em>data</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Add an io_data to the control law logs. </p>
<p>The io_data will be automatically logged among the Uz logs, if logging is enabled (see IODevice::SetDataToLog, FrameworkManager::StartLog and FrameworkManager::AddDeviceToLog). <br />
 </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">data</td><td>io_data to log </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceflair.html">flair</a></li><li class="navelem"><a class="el" href="namespaceflair_1_1meta.html">meta</a></li><li class="navelem"><a class="el" href="classflair_1_1meta_1_1_uav_state_machine.html">UavStateMachine</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
